Contributing Guidelines
=======================

Thank you for being interested in contributing to SML#.
We welcome contributions from everyone.  To contribute, please submit
a new issue or pull request on GitHub.

Please make sure that you followed the following guideline when sending
an issue or pull request.

Issues
------

* Please make sure that your Issue is for a bug or feature request.
  If you are looking for help or Q&A, please use our [forum] instead.

  [forum]: https://github.com/smlsharp/forum/discussions

* Please make sure that the issue you are pointing out is in the latest
  version of SML#. The releases except for the latest one are not
  maintained.

* Please specify the SML# version or commit hash you experienced the
  issue with.

* When filling a bug report, please include an explanation how to
  reproduce the bug that you are pointing out.

Pull Requests
-------------

* For PRs adding new features, please have a discussion with the SML#
  development team in the forum or GitHub Issues before submitting the PRs.

* Please agree that you contribute code under the same license as SML#,
  i.e, the MIT license.

* Please make sure that your PR is relative to a very recent git master.

* Please follow our coding style when contributing code.

* Please make sure to test your change before submitting your PR.
